local ret = ... or {};

ret.RedirTable =
{ -- This is mapped so that the shapes display on screen like Future Tone arcade cabinet buttons.
  -- To remap the keys for the PlayStation buttons, use this mapping:
  -- Up = "Left", Down = "Right", Left = "Down", Right = "Up"
  -- There is also a center button (star) available
	Left = "Left",
	UpLeft = "UpLeft",
	Down = "Down",
	Up = "Up",
	UpRight = "UpRight",
	Right = "Right",
};

ret.ElementRedirTable = 
{
	["Hold Head Inactive"] = "Hold Head Active",
	["Hold Topcap Inactive"] = "Hold Topcap Active",
	["Hold Body Inactive"] = "Hold Body Active",
	["Hold Bottomcap Inactive"] = "Hold Bottomcap Active",
	["Hold Tail Inactive"] = "Hold Tail Active",
	["Roll Head Inactive"] = "Roll Head Active",
	["Roll TopCap Inactive"] = "Roll Topcap Active",
	["Roll Body Inactive"] = "Roll Body Active",
	["Roll Bottomcap Inactive"] = "Roll Bottomcap Active",
	["Roll Tail Inactive"] = "Roll Tail Active",
};

local OldRedir = ret.Redir;

ret.Redir = function(sButton, sElement)
	sButton, sElement = OldRedir(sButton, sElement);
	
	sButton = ret.RedirTable[sButton] or sButton;
	sElement = ret.ElementRedirTable[sElement] or sElement;
	
	--Redirect non-directional elements to down
	if string.find(sElement, "Roll") or string.find(sElement, "Tap Explosion") or sElement == "Tap Mine" then
		sButton = "Down";
	end
	
	--Hold Elements
	if string.find(sElement, "Hold") then
		if string.find(sElement, "Hold Topcap") or string.find(sElement, "Hold Body") or string.find(sElement, "Hold Bottomcap") then
			if sButton == "UpRight" then
			sButton = "UpLeft";
			end
		end
	end

	return sButton, sElement;
end

local OldFunc = ret.Load;
function ret.Load()
	local t = OldFunc();

	-- The main "Explosion" part just loads other actors; don't rotate
	-- it.  The "Hold Explosion" part should not be rotated.
	-- if Var "Element" == "Explosion" or
	--   Var "Element" == "Roll Explosion" then
		t.BaseRotationZ = nil;
	-- end
	return t;
end

ret.Blank =
{
	["Hold Explosion"] = true,
	["Roll Explosion"] = true,
	["Roll Topcap Active"] = true,
	["Roll Topcap Inactive"] = true,
	["Roll Tail Active"] = true,
	["Roll Tail Inactive"] = true,
};

return ret;
